// DfCom.cpp : Legt die Initialisierungsroutinen fr die DLL fest.
//

#include "stdafx.h"
#include "DfCom.h"
#include "Com.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//
//	Beachten Sie!
//
//		Wird diese DLL dynamisch an die MFC-DLLs gebunden,
//		muss bei allen von dieser DLL exportierten Funktionen,
//		die MFC-Aufrufe durchfhren, das Makro AFX_MANAGE_STATE
//		direkt am Beginn der Funktion eingefgt sein.
//
//		Beispiel:
//
//		extern "C" BOOL PASCAL EXPORT ExportedFunction()
//		{
//			AFX_MANAGE_STATE(AfxGetStaticModuleState());
//		// Hier normaler Funktionsrumpf
//		}
//
//		Es ist sehr wichtig, dass dieses Makro in jeder Funktion
//		vor allen MFC-Aufrufen erscheint. Dies bedeutet, dass es
//		als erste Anweisung innerhalb der Funktion ausgefhrt werden
//		muss, sogar vor jeglichen Deklarationen von Objektvariablen,
//		da ihre Konstruktoren Aufrufe in die MFC-DLL generieren
//		knnten.
//
//		Siehe MFC Technical Notes 33 und 58 fr weitere
//		Details.
//

/////////////////////////////////////////////////////////////////////////////
// CDfComApp

BEGIN_MESSAGE_MAP(CDfComApp, CWinApp)
	//{{AFX_MSG_MAP(CDfComApp)
		// HINWEIS - Hier werden Mapping-Makros vom Klassen-Assistenten eingefgt und entfernt.
		//    Innerhalb dieser generierten Quelltextabschnitte NICHTS VERNDERN!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDfComApp Konstruktion

CDfComApp::CDfComApp()
{
	// ZU ERLEDIGEN: Hier Code zur Konstruktion einfgen
	// Alle wichtigen Initialisierungen in InitInstance platzieren
}

/////////////////////////////////////////////////////////////////////////////
// Das einzige CDfComApp-Objekt

CDfComApp theApp;
CCom	Com;
CCom	Com2;

// Exportierte Funktionen

extern "C" __declspec(dllexport) int __stdcall Init(int ComNr)
// Schnittstelle zum Datafox AE initialisieren
// ComNr -> Nr. der Schnittstelle; 1 -> COM1; 2 -> COM2 ...
// Return	0 -> Fehler (COM nicht vorhanden; COM bereits belegt ...)
//			1 -> OK
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	return Com.ComInit(ComNr-1);
}

extern "C" __declspec(dllexport) void __stdcall Close()
// Schnittstelle zum Datafox AE schliesen
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	Com.ComClose();
}

extern "C" __declspec(dllexport) int __stdcall 
	GetDatenOnline(int BusNum, int *Kennung, char *DateTime,int *Z1,int *Z2,int *Z3,int *Z4,int *Z5,int *Z6)
// Datafox AE mit der Busnummer "BusNum" pollen.
// Wenn ein Datensatz im Datafox vorhanden ist, ist der Rckgabewert "1" und
// in den Var. Kennungen, DateTime, Z1 ... Z6 wird der Datensatz zurckgegeben.
// Wurde ein Datensatz mit "GetDatenOnline" abgefragt, wird er nicht im internen Ringspeicher
// des Datafox abgelegt und kann nicht mit "GetDatenOffline" erneut abgeholt werden!
// BusNum	-> Busnummer des Datafox welches abgefragt wird
// Die folgenden Variablen haben nur einen gltigen Wert, wenn der Rckgabewert = "1" ist:
//		Kennung		-> am Datafox eingegebene Kennung 
//		DateTime	-> Datum und Uhrzeit des Datensatzes. Format: "20.11.1999 17:16:35"
//					   Achtung: der Pointer DateTime mu auf einen ausreichend groen Specherbereich zeigen!
//		Z1...Z6		-> Werte der Z-Felder (0 wenn Z-Feld im Datafox nicht verwendet wird)
// Return 1	-> Datensatz vorhanden
// Return 0 -> kein Datensatz vorhanden oder Fehler der Kommunikation
// Return 2 -> Fehler: keine Kommunikation
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	TDatensatz dat;
	CString st;
	int i,ret;

	if ((ret=Com.GetDatOnline(BusNum,&dat))==1) {// ein Datensatz aus Datafox lesen
		*Kennung = dat.k;
		*Z1 = dat.z[0]; *Z2 = dat.z[1]; *Z3 = dat.z[2]; 
		*Z4 = dat.z[3]; *Z5 = dat.z[4]; *Z6 = dat.z[5]; 
		CTime dt(dat.date_time);
		st = dt.Format("%d.%m.%Y %H:%M:%S");
		for (i=0;i<st.GetLength();i++) DateTime[i] = st[i];
		DateTime[i] = 0;
		return 1;
	}else{
		return ret;
	}	
}

extern "C" __declspec(dllexport) void __stdcall 
	SendMessageOnline(int BusNum, int ErrFlag, char *Message)
// Text an Datafox senden.
// Die Funtion wird aufgerufen nachdem mit "GetDatenOnline" ein Datensatz ebgeholt wurde.
// Der bergebene Text wird auf dem Display des Datafox eine gewisse Zeit angezeitgt.
// Ist das Flag "ErrFlag" gesetzt, wird zustzlich mit dem Summer des Datafox eine Fehler signalisiert.
// Der Text wird nur angezeigt, wenn die Funktion innerhalb eines Zeitfensters nach "GetDatenOnline"
// aufgerufen wird.
// BusNum	-> Busnummer des Datafox
// ErrFlag	->	1 -> Summer aktivieren
//				0 -> Summer nicht aktivieren
// Return	-> kein Rckgabewert
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	Com.SendMess(BusNum,ErrFlag,Message);
}

extern "C" __declspec(dllexport) int __stdcall 
	GetDatenOffline(int BusNum, int *Kennung, char *DateTime, int *Z1, int *Z2, int *Z3, int *Z4, int *Z5, int *Z6)
// Im Datafox gespeicherte Daten auslesen
// Wenn im Onlinebetrieb der Datensatz nach einer definierten Zeit nicht abgeholt wurde (mit GetDatenOnline),
// wird der Datensatz im internen Ringspeicher abgelegt (Notlauffunktion).
// Ein Annehmen oder Ablehnen des Datensatzes ist dann nicht mehr mglich.
// BusNum	-> Busnummer des Datafox welches abgefragt wird
// Die folgenden Variablen haben nur einen gltigen Wert, wenn der Rckgabewert = "1" ist:
//		Kennung		-> am Datafox eingegebene Kennung 
//		DateTime	-> Datum und Uhrzeit des Datensatzes Format: "20.11.1999 17:16:35"
//					   Achtung: der Pointer "DateTime" mu auf einen ausreichend groen Speicherbereich zeigen!
//		Z1...Z6		-> Werte der Z-Felder (0 wenn Z-Feld im Datafox nicht verwendet wird)
// Return 1	-> Datensatz erfolgreich abgefragt
// Return 0 -> kein Datensatz vorhanden
// Return 2 -> Fehler: keine Kommunikation
{
	TDatensatz dat;
	CString st;
	int i,ret;

	if ((ret=Com.GetDatensatzAndClr(BusNum,&dat))==1) {// ein Datensatz aus Datafox lesen
		*Kennung = dat.k;
		*Z1 = dat.z[0]; *Z2 = dat.z[1]; *Z3 = dat.z[2]; 
		*Z4 = dat.z[3]; *Z5 = dat.z[4]; *Z6 = dat.z[5]; 
		CTime dt(dat.date_time);
		st = dt.Format("%d.%m.%Y %H:%M:%S");
		for (i=0;i<st.GetLength();i++) DateTime[i] = st[i];
		DateTime[i] = 0;
		return 1;
	}else{
		return ret;
	}	
}

// Exportierte Funktionen fr zweite Com
// Funktion Gleich wie F. fr erste Com

extern "C" __declspec(dllexport) int __stdcall Init2(int ComNr)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	return Com2.ComInit(ComNr-1);
}

extern "C" __declspec(dllexport) void __stdcall Close2()
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	Com2.ComClose();
}

extern "C" __declspec(dllexport) int __stdcall 
	GetDatenOnline2(int BusNum, int *Kennung, char *DateTime,int *Z1,int *Z2,int *Z3,int *Z4,int *Z5,int *Z6)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	TDatensatz dat;
	CString st;
	int i,ret;

	if ((ret=Com2.GetDatOnline(BusNum,&dat))==1) {// ein Datensatz aus Datafox lesen
		*Kennung = dat.k;
		*Z1 = dat.z[0]; *Z2 = dat.z[1]; *Z3 = dat.z[2]; 
		*Z4 = dat.z[3]; *Z5 = dat.z[4]; *Z6 = dat.z[5]; 
		CTime dt(dat.date_time);
		st = dt.Format("%d.%m.%Y %H:%M:%S");
		for (i=0;i<st.GetLength();i++) DateTime[i] = st[i];
		DateTime[i] = 0;
		return 1;
	}else{
		return ret;
	}	
}

extern "C" __declspec(dllexport) void __stdcall 
	SendMessageOnline2(int BusNum, int ErrFlag, char *Message)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	Com2.SendMess(BusNum,ErrFlag,Message);
}

extern "C" __declspec(dllexport) int __stdcall 
	GetDatenOffline2(int BusNum, int *Kennung, char *DateTime, int *Z1, int *Z2, int *Z3, int *Z4, int *Z5, int *Z6)
{
	TDatensatz dat;
	CString st;
	int i,ret;

	if ((ret=Com2.GetDatensatzAndClr(BusNum,&dat))==1) {// ein Datensatz aus Datafox lesen
		*Kennung = dat.k;
		*Z1 = dat.z[0]; *Z2 = dat.z[1]; *Z3 = dat.z[2]; 
		*Z4 = dat.z[3]; *Z5 = dat.z[4]; *Z6 = dat.z[5]; 
		CTime dt(dat.date_time);
		st = dt.Format("%d.%m.%Y %H:%M:%S");
		for (i=0;i<st.GetLength();i++) DateTime[i] = st[i];
		DateTime[i] = 0;
		return 1;
	}else{
		return ret;
	}	
}
